# Cancel refund

Use the **cancelRefund** method to issue a total refund for an order processed by 2Checkout.

## Requested parameters <a href="#requested-parameters" id="requested-parameters"></a>

This method allows you to cancel a refund initiated from the cPanel or to decline a refund initiated by the shopper from myAccount.

The status of the refund needs to be PENDING or APPROVED.

The refund can be cancelled in up to 2 hours from the initiation.&#x20;

### Request sample  <a href="#request-sample__00a0" id="request-sample__00a0"></a>

```php
<?php

declare(strict_types=1);

class Configuration
{
    public const MERCHANT_CODE = 'AVANGATE';
    public const MERCHANT_KEY = 'SECRET_KEY';
    public const URL = 'https://api.2checkout.com/soap/6.0';
    public const ACTION = 'cancelRefund';
    public const ADDITIONAL_OPTIONS = null;
    public const ORDER_REF = '73152889';
    //array or JSON
    public const PAYLOAD = null;

}

class Client
{
    public function call(
        string $url = Configuration::URL,
        $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION
    ): ?object {
        if (is_array($payload)) {
            $payload = json_encode($payload);
        }
        if (!empty($payload)) {
            // SoapClient works with objects(StdClass)
            $payload = json_decode($payload);
        }
        $soapClient = $this->getClient($url);
        $sessionId = $this->getSession($soapClient);
        $args = array_filter([$sessionId, Configuration::ORDER_REF, $payload]);

        return $soapClient->$action(...$args);
    }

    public function getClient(string $url): SoapClient
    {
        return new SoapClient(
            $url . '?wsdl',
            [
                'location'   => $url,
                'cache_wsdl' => WSDL_CACHE_NONE,
            ]
        );
    }

    public function getSession(SoapClient $client)
    {
        $date = gmdate('Y-m-d H:i:s');
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $string = strlen($merchantCode) . $merchantCode . strlen($date) . $date;
        $algo = 'sha256';
        $hash = hash_hmac($algo, $string, $key);
        $client->__setCookie('XDEBUG_SESSION', 'PHPSTORM');

        return $client->login($merchantCode, $date, $hash, $algo);
    }
}

try {
    $client = new Client();
    var_dump($client->call());
} catch (Exception $ex) {
    var_dump($ex);
}
```

## Response parameters <a href="#response" id="response"></a>

| **Response** | **Type/Description**              |
| ------------ | --------------------------------- |
| **RefundID** | The ID generated for this refund. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/refund-an-order/cancel-refund.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
